# -*- perl -*-
use lib qw(t lib);
use strict;
use Test;
use Config::Tree qw(:sort);
use Data::Dumper;

plan(tests => 1);

my $t = new Config::Tree(
    parameters => {
	x => {
	    section => {
		number => { array => 1 },
		name => 1
	    }
    	}
    });

my $node = new Config::Tree::Node::Section;
$node->subtree(number => new Config::Tree::Node::Value(
		   value => [1],
		   locus => new Config::Tree::Locus('input',1)));
$node->subtree(name => new Config::Tree::Node::Value(
		   value => 'foo',
		   locus => new Config::Tree::Locus('input',2)));
$t->add_node(x => $node);

$node = new Config::Tree::Node::Section;
$node->subtree(number => new Config::Tree::Node::Value(
		   value => 2,
		   locus => new Config::Tree::Locus('input',3)));
$node->subtree(name => new Config::Tree::Node::Value(
		   value => 'bar',
		   locus => new Config::Tree::Locus('input',4)));
$t->add_node(x => $node);

ok(join(' ', map {
	local $Data::Dumper::Useqq = 1;
	local $Data::Dumper::Terse = 1;
	local $Data::Dumper::Indent = 0;
	'['.$_->[1]->locus . ']: '.
	join('.', @{$_->[0]}) . "=" . Data::Dumper->Dump([$_->[1]->value]);
	} $t->flatten(sort => SORT_PATH)),
    q{[input:2]: x.name="bar" [input:1,3]: x.number=[1,2]});
